(add-to-list 'default-frame-alist '(top . 0))
(add-to-list 'default-frame-alist '(left . 0))
(add-to-list 'default-frame-alist '(width . 130))
(add-to-list 'default-frame-alist '(height . 56))
;(add-to-list 'default-frame-alist '(font . "Sarasa Mono CL 12"))
(when nil

(when window-system
  (set-fontset-font "fontset-default" 'han "Sarasa Mono CL")
  (set-fontset-font "fontset-default" 'kana "Sarasa Mono CL")
  (define-fringe-bitmap 'right-arrow
    [#b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000])
  (define-fringe-bitmap 'left-arrow
    [#b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000])
  (define-fringe-bitmap 'right-curly-arrow
    [#b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000 #b11000000 #b11000000
     #b00000000 #b00000000])
  (define-fringe-bitmap 'left-curly-arrow
    [#b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000 #b00000011 #b00000011
     #b00000000 #b00000000]))

;; (require 'url)
;; (setq url-proxy-services
;;       '(("http" . "127.0.0.1:8087")
;;         ("https" . "127.0.0.1:8087")))

(setq load-prefer-newer t)
(require 'package) ;; You might already have this line
(let* ((no-ssl (and (memq system-type '(windows-nt ms-dos))
                    (not (gnutls-available-p))))
       (proto (if no-ssl "http" "https")))
  ;; Comment/uncomment these two lines to enable/disable MELPA and MELPA Stable as desired
  (add-to-list 'package-archives (cons "melpa" (concat proto "://melpa.org/packages/")) t)
  ;;(add-to-list 'package-archives (cons "melpa-stable" (concat proto "://stable.melpa.org/packages/")) t)
  (when (< emacs-major-version 24)
    ;; For important compatibility libraries like cl-lib
    (add-to-list 'package-archives '("gnu" . (concat proto "://elpa.gnu.org/packages/")))))
(when (< emacs-major-version 27) (package-initialize)) ;; You might already have this line
(require 'auto-compile)
;;(auto-compile-on-load-mode)
(auto-compile-on-save-mode)

(add-to-list 'exec-path "/usr/bin")

(setq make-backup-files nil)
(setq auto-save-default nil)

)
(push "/home/rpluim/repos/emacs-master/lisp/smart-mode-line-master" load-path)
(require 'smart-mode-line)
(setq sml/no-confirm-load-theme t)
(sml/setup)
(when nil
(require 'geiser-mode)
(setq scheme-program-name "guile")
(setq geiser-guile-binary  "guile")
(setq geiser-active-implementations '(guile))
(setq geiser-mode-start-repl-p t)
(setq geiser-repl-query-on-kill-p nil)

(electric-indent-mode -1)
(setq-default indent-tabs-mode nil)
(smart-tabs-insinuate 'c 'c++ 'java)
(add-hook 'before-save-hook 'delete-trailing-whitespace)
(add-hook 'before-save-hook (lambda () (untabify (point-min) (point-max))))

(require 'yasnippet)
(yas-reload-all)
(add-hook 'c-mode-common-hook #'yas-minor-mode)

(require 'lsp-ui)
(add-hook 'lsp-mode-hook 'lsp-ui-mode)

;;company-lsp is -ls ;company-c-headers is c-c-h
(require 'cquery)
(setq cquery-executable "/usr/bin/cquery")

(eval-when-compile (require 'cl))

(defun company-cquery-headers-fun ()
  (defun get-suffix (list)
    (if (eq list nil) nil (if (eq (cdr list) nil) (car list) (get-suffix (cdr list)))))
  (defun is-file (filename)
    ((lambda (suffix)
       (if (eq nil suffix) nil
         (member-ignore-case suffix '("c" "cc" "cpp" "cxx" "cp" "c++" "m" "mm" "h" "hh" "hpp" "hxx" "hp" "h++"))))
     (get-suffix ((lambda (filename) (split-string filename "." t)) filename))))
  (defun filter-file (list)
    (if (eq nil list) nil
      (let ((suffix-list (is-file (car list)))
            (processed-list (filter-file (cdr list))))
        (if (eq nil suffix-list)
            (let ((str (car list)))
              (cons (if (char-equal (string-to-char str) ?%) "clang" str) processed-list))
          (cons (concat "-x" ((lambda (addr)
                                (if (string= addr "objc") "objective-c" addr))
                              (car (split-string (format "%s" major-mode) "-" t))))
                processed-list)))))
  (defun build-command (list)
    (if (eq nil list) "-E -v - < /dev/null"
      (concat (car list) " " (build-command (cdr list)))))
  (defun command-output ()
    ((lambda (output) (split-string output "\n" t))
     (shell-command-to-string
      (build-command (filter-file (gethash "args" (cquery-file-info)))))))
  (let ((rest-list nil))
    (defun export-user (list not-noise)
      (if not-noise
          (if (string= "#include <...> search starts here:" (car list))
              (progn (setq rest-list (cdr list)) nil)
            (cons (car (split-string (car list) " " t)) (export-user (cdr list) t)))
        (export-user (cdr list) (string= "#include \"...\" search starts here:" (car list)))))
    (lexical-let ((user-list (cons "." (export-user (command-output) nil))))
      (defun export-system (list)
        (if (string= "End of search list." (car list)) nil
          (cons (car (split-string (car list) " " t)) (export-system (cdr list)))))
      (lexical-let ((system-list (export-system rest-list)))
        #'(lambda (t4user-nil4system) (if t4user-nil4system user-list system-list))))))

(require 'company-c-headers)

(defun set-headers-from-cquery ()
  (let ((timer nil) (noerror nil))
    (let ((set-path
           (lambda ()
             (setq noerror (ignore-errors (gethash "args" (cquery-file-info) nil)))
             (if noerror (progn (ignore-errors (cancel-timer timer))
                                (let ((path-fun (company-cquery-headers-fun)))
                                  (setq company-c-headers-path-user (funcall path-fun t))
                                  (setq company-c-headers-path-system (funcall path-fun nil))))
               nil))))
      (setq timer (run-with-idle-timer 1 t set-path)))))

(add-hook 'c-mode-common-hook
          (lambda ()
            (setq tab-width 4)
            (smart-tabs-mode 1)
            (add-hook 'lsp-after-initialize-hook 'set-headers-from-cquery)
            (require 'company-lsp)
            (lsp-cquery-enable)))

;;column line
(require 'fill-column-indicator)
(add-hook 'prog-mode-hook 'fci-mode)
(setq-default fill-column 80)
(setq fci-rule-color "dimgray")

;;column line with company mode
(defvar-local company-fci-mode-on-p nil)

(defun company-turn-off-fci (&rest ignore)
  (when (boundp 'fci-mode)
    (setq company-fci-mode-on-p fci-mode)
    (when fci-mode (fci-mode -1))))

(defun company-maybe-turn-on-fci (&rest ignore)
  (when company-fci-mode-on-p (fci-mode 1)))

(add-hook 'company-completion-started-hook 'company-turn-off-fci)
(add-hook 'company-completion-finished-hook 'company-maybe-turn-on-fci)
(add-hook 'company-completion-cancelled-hook 'company-maybe-turn-on-fci)

(smartparens-global-mode 1)
(show-smartparens-global-mode 1)

(global-set-key (kbd "M-p s") 'sp-splice-sexp)
(global-set-key (kbd "M-p r") 'sp-rewrap-sexp)
;; lisps
(global-set-key (kbd "M-p ,") 'sp-forward-barf-sexp)
(global-set-key (kbd "M-p .") 'sp-forward-slurp-sexp)
(global-set-key (kbd "M-p ]") 'sp-down-sexp)
(global-set-key (kbd "M-p [") 'sp-backward-up-sexp)
;; non lisps
(global-set-key (kbd "M-p /") 'sp-forward-slurp-hybrid-sexp)
(global-set-key (kbd "M-p =") 'sp-forward-sexp)
(global-set-key (kbd "M-p -") 'sp-backward-sexp)

(add-hook 'after-init-hook 'global-company-mode)
(global-flycheck-mode)
(setq-default flycheck-disabled-checkers '(emacs-lisp-checkdoc c/c++-cppcheck c/c++-gcc c/c++-clang))

(require 'linum)

(defvar my-linum-format-string "%6d")

(defun my-linum-get-format-string ()
  (let* ((width (length (number-to-string
                         (count-lines (point-min) (point-max)))))
         (format (concat "%" (number-to-string width) "d"))
         (mode-line-number (concat "%" (number-to-string width) "l")))
    (setq my-linum-format-string format)
    (setq mode-line-front-space `(:propertize ,mode-line-number face (:weight bold)))))

(defun my-linum-format (line-number)
  (propertize (format my-linum-format-string line-number) 'face 'linum))

(add-hook 'find-file-hook (lambda () (linum-mode 1)))
(add-hook 'linum-before-numbering-hook 'my-linum-get-format-string)

(setq linum-format 'my-linum-format)

(defun set-no-process-query-on-exit ()
  (let ((proc (get-buffer-process (current-buffer))))
    (when (processp proc)
      (set-process-query-on-exit-flag proc nil))))

(add-hook 'term-exec-hook 'set-no-process-query-on-exit)

(add-hook 'eshell-mode-hook (lambda () (company-mode -1)))
)
(require 'em-tramp)
(when nil
(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(auth-source-save-behavior nil)
 '(auto-compile-display-buffer nil)
 '(byte-compile-warnings nil)
 '(company-backends
   '(company-c-headers company-lsp company-bbdb company-nxml company-css company-cmake company-capf company-files
                       (company-dabbrev-code company-keywords)
                       company-oddmuse company-dabbrev))
 '(company-lsp-async t)
 '(company-lsp-cache-candidates nil)
 '(company-lsp-enable-recompletion t)
 '(custom-enabled-themes '(smart-mode-line-respectful))
 '(custom-safe-themes
   '("c74e83f8aa4c78a121b52146eadb792c9facc5b1f02c917e3dbb454fca931223" "a27c00821ccfd5a78b01e4f35dc056706dd9ede09a8b90c6955ae6a390eb1c1e" "3c83b3676d796422704082049fc38b6966bcad960f896669dfc21a7a37a748fa" default))
 '(eshell-prefer-lisp-functions t)
 '(eshell-prefer-lisp-variables t)
 '(flycheck-check-syntax-automatically '(save mode-enabled))
 '(inhibit-startup-screen t)
 '(lsp-enable-indentation nil)
 '(lsp-highlight-symbol-at-point nil)
 '(lsp-ui-imenu-enable nil)
 '(lsp-ui-sideline-enable nil)
 '(package-selected-packages
   '(auto-compile lsp-ui yasnippet company-c-headers company-lsp cquery lsp-mode smart-tabs-mode fill-column-indicator flycheck-clang-analyzer flycheck ## clang-format cl-lib company geiser smart-mode-line smartparens))
 '(password-cache-expiry 3600))

(custom-set-faces
 ;; custom-set-faces was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 )

)
